/*#######################################################################################
AVR DCF77 Clock

Copyright (C) 2005 Ulrich Radig

http://www.ulrichradig.de/home/index.php/avr/dcf77_uhr
http://www.ulrichradig.de/home/uploads/File/AVR_DCF77/SourceCode.zip

passt fr IRMP-Schaltung

#######################################################################################*/

#ifndef _CLOCK_H
 #define _CLOCK_H

//uint8_t j;			//in main, Zhlvariable fr EEPROM-Schreiben und Lesen
char Buffer2[10];	//fr itoa, fr EEPROM-Schreiben und Lesen

//zum Aufruf von "sync_memory"
volatile extern unsigned char ss;	//Globale Variable fr Sekunden
volatile extern unsigned char mm;	//Globale Variable fr Minuten
volatile extern unsigned char hh;	//Globale Variable fr Stunden
volatile extern unsigned char day;	//Globale Variable fr den Tag
volatile extern unsigned char mon;	//Globale Variable fr den Monat
volatile extern unsigned int year;	//Globale Variable fr den Jahr
volatile extern unsigned char weekday0;  //Globale Variable fr das Jahr hinzugefgt chr, mu hier ohne Vorgabe-Wert stehen!!!


/*
volatile unsigned char ss;	//Globale Variable fr Sekunden
volatile unsigned char mm;	//Globale Variable fr Minuten
volatile unsigned char hh;	//Globale Variable fr Stunden
volatile unsigned char day;	//Globale Variable fr den Tag
volatile unsigned char mon;	//Globale Variable fr den Monat
volatile unsigned int year;	//Globale Variable fr den Jahr
volatile unsigned char weekday = 0;  //Globale Variable fr das Jahr hinzugefgt chr
*/

extern void Start_RC5(void);		//in Version clock5b.c neu  hinzugefgt
extern void Start_Clock (void); //Startet die DCF77 Uhr
extern void Add_one_Second (void);
extern void Alle_bits_anzeigen1 (unsigned long long k);			//neu
extern void Spezial_bits_anzeigen (void);						//neu
extern void Wochentag_anzeigen (void);							//neu
extern void RC5_Empfang (void);									//neu

/*
extern void initAT24();
uint8_t AT24LC1025DummyWriteByte(uint32_t dataaddress);
uint8_t AT24LC1025WriteByte(uint32_t dataaddress, uint8_t data);
uint8_t AT24LC1025ReadByte(uint32_t dataaddress);
uint8_t AT24LC1025WritePage(uint32_t dataaddress, uint8_t data, uint8_t anzahl_bytes);
uint8_t AT24LC1025ReadPage(uint32_t dataaddress, uint8_t anzahl_bytes);
void AT24C1025_EEPROM_loeschen (void);
void AT24LC1025Poll(uint8_t rw);
void AT24LC1025_Inhalt_anzeigen (uint8_t laenge, uint8_t eintraegeprozeile, uint8_t zeilenproseite, uint32_t startadresse);
*/




//64 Bit fr DCF77 bentigt werden 59 Bits
volatile unsigned long long dcf_rx_buffer;
//RX Pointer (Counter)
volatile extern unsigned char rx_bit_counter;
//Hilfs Sekunden Counter
volatile unsigned int h_ss;


#define use_I2C_LCD	//I2C-LCD verwenden. Auskommentieren, falls unbenutzt.
//#define sync_memory_enabled		//auskommentieren, falls kein EEPROM verwendet wird; zum Loggen der sync-get/sync-loss- Ereignisse

//uint8_t j;			//in main, Zhlvariable fr EEPROM-Schreiben und Lesen
//char Buffer[10];	//fr itoa, fr EEPROM-Schreiben und Lesen	-->> nach RC5.h


#if defined (__AVR_ATmega128__)
	//Interrupt an dem das DCF77 Modul hngt hier INT0
	#define DCF77_INT_ENABLE()	EIMSK |= (1<<INT0);
	#define DCF77_INT			SIG_INTERRUPT0
	#define INT0_CONTROL		EICRA
	#define INT0_FALLING_EDGE	0x02
	#define INT0_RISING_EDGE	0x03
	#define TIMSK1 				TIMSK
#endif

#if defined (__AVR_ATmega32__)
	//Interrupt an dem das DCF77 Modul hngt hier INT0
	#define DCF77_INT_ENABLE()	GICR |= (1<<INT0);
	#define DCF77_INT			SIG_INTERRUPT0
	#define INT0_CONTROL		MCUCR
	#define INT0_FALLING_EDGE	0x02
	#define INT0_RISING_EDGE	0x03
	#define TIMSK1 				TIMSK
#endif

#if defined (__AVR_ATmega8__)
	//Interrupt an dem das DCF77 Modul hngt hier INT0
	#define DCF77_INT_ENABLE()	GICR |= (1<<INT0);
	#define DCF77_INT			SIG_INTERRUPT0
	#define INT0_CONTROL		MCUCR
	#define INT0_FALLING_EDGE	0x02
	#define INT0_RISING_EDGE	0x03
    #define TIMSK1              TIMSK
#endif

#if defined (__AVR_ATmega88__)
	//Interrupt an dem das DCF77 Modul hngt hier INT0
	#define DCF77_INT_ENABLE()	EIMSK |= (1<<INT0);
	#define DCF77_INT			SIG_INTERRUPT0	//zur Erkennung der Flanken am Eingangs-Pin -->> INT0 =  PD2 = Pin4
	#define INT0_CONTROL		EICRA
	#define INT0_FALLING_EDGE	0x02
	#define INT0_RISING_EDGE	0x03
#endif

//Zusatz: Erweitert fr Mega48. Es gelten die gleichen Definitionen wie beim Mega88.
#if defined (__AVR_ATmega48__)
	//Interrupt an dem das DCF77 Modul hngt hier INT0
	#define DCF77_INT_ENABLE()	EIMSK |= (1<<INT0);
	#define DCF77_INT			SIG_INTERRUPT0 //zur Erkennung der Flanken am Eingangs-Pin -->> INT0 =  PD2 = Pin4
	#define INT0_CONTROL		EICRA
	#define INT0_FALLING_EDGE	0x02
	#define INT0_RISING_EDGE	0x03
#endif

//Structur des dcf_rx_buffer
struct  DCF77_Bits {
	unsigned char M			    :1	;
	unsigned char O1			:1	;
	unsigned char O2			:1	;
	unsigned char O3			:1	;
	unsigned char O4			:1	;
	unsigned char O5			:1	;
	unsigned char O6			:1	;
	unsigned char O7			:1	;
	unsigned char O8			:1	;
	unsigned char O9			:1	;
	unsigned char O10			:1	;
	unsigned char O11			:1	;
	unsigned char O12			:1	;
	unsigned char O13			:1	;
	unsigned char O14			:1	;
	unsigned char R			    :1	;//0=Normalantenne, 1=Reserveantenne
	unsigned char A1			:1	;// 1=Am Ende dieser Stunde wird MEZ/MESZ umgestellt
	unsigned char Z1			:1	;//0=MEZ, 1=MESZ	//korrigiert
	unsigned char Z2			:1	;//0=MESZ, 1=MEZ	//korrigiert
	unsigned char A2			:1	;//1=Am Ende dieser Stunde wird eine Schaltsekunde eingefgt
	unsigned char S			    :1	;//Startbit, ist immer 1
	unsigned char Min			:7	;//7 Bits fr die Minuten
	unsigned char P1			:1	;//Parity Minuten
	unsigned char Hour			:6	;//6 Bits fr die Stunden
	unsigned char P2			:1	;//Parity Stunden
	unsigned char Day			:6	;//6 Bits fr den Tag
	unsigned char Weekday		:3	;//3 Bits fr den Wochentag 
	unsigned char Month		    :5	;//3 Bits fr den Monat
	unsigned char Year		    :8	;//8 Bits fr das Jahr **eine 5 fr das Jahr 2005**
	unsigned char P3			:1	;//Parity von P2
	};
	
struct 
	{
	volatile char parity_err					:1	;//Hilfs Parity
	volatile char parity_P1					:1	;//Berechnetes Parity P1
	volatile char parity_P2					:1	;//Berechnetes Parity P2
	volatile char parity_P3					:1	;//Berechnetes Parity P3
	volatile char dcf_rx					:1	;//Es wurde ein Impuls empfangen
	volatile char dcf_sync					:1	;//In der letzten Minuten wurde die Uhr syncronisiert
	}flags;
	
#endif //_CLOCK_H
