/*#######################################################################################
AVR DCF77 Clock 

Copyright (C) 2005 Ulrich Radig

http://www.ulrichradig.de/home/index.php/avr/dcf77_uhr
http://www.ulrichradig.de/home/uploads/File/AVR_DCF77/SourceCode.zip

Auswertung der Zeitzone findet berhaupt nicht statt.

passt fr IRMP-Schaltung, Mega48, Mega88		jeweils mit 8MHz internem Oszillator

Die in "sync_memory" aufgerufenen Unterprogramme befinden sich fr ein AT24C08-EEPROM in AT24C_3.c und fr ein AT24LC1025 in AT24LC1025.c
Je nach verwendetem EEPROM-Typ die entsprechende  Datei mit ins Projekt einbinden und die Aufrufe umbenennen.

clock2.c enthlt die Ausgabe der 64-Bit breiten Variablen als Schleife und zustzlich RC5-Empfang.
clock3.c soll Auswertung der drei speziellen Bits NR, 15, 16, 19 und Menbedienung per RC5-Fernbedienung erhalten.
Auswertung des Antennen-Bits Nr15 und des Warnungs-Bits fr die Zeitumstellung bit 16, Schaltsekunde Bit19 Vorwarnungs-Bit,
Falls gesetzt, soll Anzeigentext blinken!
Ausgabe des Wochentages fehlt noch vllig!!! Ist mittlerweise dabei.
Ausgabe der 64-bit breiten Variablen durch Striche unterteilt.

clock4.c
Neues Unterprogramm hinzu gefgt, das die 64-Bits breite Variable nun korrekt ausgibt. verwendet if (k & ((unsigned long long) 1 << j))
Bedienung per Men fehlt noch vllig, da der Flash des Mega48 inzwischen bereits voll ausgelastet ist.
Weitere Entwicklung fr's Men mit Mega88.

In clock.h knnte man noch ein struct erstellen, das Flags enthlt, die auf einzelne Tastendrcke der RC5-Fernbedienung reagieren.
Z.B. toggelt die Fernbedienung einzelne Bits, so da man "Spezial_bits_anzeigen", "Alle_bits_anzeigen1", "Wochentag_anzeigen"
ein und aus schalten kann.


clock5.c
Neues Unterprogramm erstellt, das bei sync-Verlust oder Sync-Wiederkehr die Zeit ins EEPROM speichert.
Hier gab es extreme Probleme mit den groen Zahlen und den vielen Parametern. Das Programm las immer falsche Zahlen und 
die Darstellung der 32-Bit-Adresse als Dezimalzahl war ebenfalls falsch. Das Schreiben in die ersten vier Adressen
war ebenfalls fehlerhaft. Vermutung: Stack-berlauf wegen den vielen Parametern und Unterprogrammen.
Durch Expierimente stellte sich heraus, da die verwendeten Programmzeilen trotzdem korrekt sind, zumal im anderen 
Unterprogramm das Lesen der Adressen korrekt verlief. Abhilfe: Die Funktionalitt von "sync-memory" auf mehrere 
Unterprogramme aufteilen. Ob diese innerhalb oder auerhab von "sync-memory" liegen, bleibt auszuprobieren.

clock5a.c
Enthlt zustzliche Kommentare, die das Verstndnis der Parity-Verarbeitung dienen sollen.

clock5b.c
entstand neu mit dem hinzu Fgen der I2C-Routinen frs Display. 
Etliche unntige Sachen gelscht, wie z.B. EEPROM-Routinen, Syncmemory....
Zeigt Wochentag, Datum, Uhrzeit auf dem I2C-Display an. Ebenso die Spezialbits.
Lschung des displays erfolgt zur vollen Minute. Leider bleibt das Programm dann nach einigen Minuten hngen.


Umschalten der Puls-Polaritt durch bedingte Compilierung. 
#######################################################################################*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include "clock.h"
#include "usart.h"

//#include "LCD-Routines.h"			//fr neue Schaltung normales LCD
#include "LCD-RoutinesI2C-4x40.h"	//fr neue Schaltung 4x40 LCD mit Licht
//#include "LCD-RoutinesI2C.h"		//fr neue Schaltung 2x40 LCD ohne Licht

#include "RC5.h"			//fr RC5-Empfang
//#include <C:\WinAVR-20100110\avr\include\stdlib.h>		//fr itoa fr RC5-Empfang
#include <stdlib.h>		//fr itoa fr RC5-Empfang
#include <util/delay.h>	//fr Warteschleifen
//#include <avr/eeprom.h>	//um das EEPROM des Cs anzusprechen. Es soll die letzte beschriebene Adresse des I2C-EEPROMs gespeichert werden.
						//Idee: die letzte Beschriebene Adresse knnte man auch an erster oder letzter Stelle des EEPROMs speichern!!!

//Die Uhrzeit steht in folgenden Variablen
volatile unsigned char ss   = 0;   //Globale Variable fr die Sekunden
volatile unsigned char mm   = 0;   //Globale Variable fr die Minuten
volatile unsigned char hh   = 0;   //Globale Variable fr die Stunden
volatile unsigned char day   = 0;   //Globale Variable fr den Tag
volatile unsigned char mon   = 0;   //Globale Variable fr den Monat
volatile unsigned int year   = 0;   //Globale Variable fr das Jahr
volatile unsigned char weekday;  //Globale Variable fr den Wochentag hinzugefgt chr

//Bitzhler fr RX Bit
volatile unsigned char rx_bit_counter = 0;

//64 Bit fr DCF77 bentigt werden 59 Bits
volatile unsigned long long dcf_rx_buffer = 0;

//Hilfs Sekunden Counter
volatile unsigned int h_ss = 0;

//Hilfs Variable fr Stundenwechsel
volatile unsigned int h_hh = 0;

//Variablen fr RC5-Empfang
//unsigned int i;
//char Buffer[10];	//fr itoa

//globale Variable zum Zahlen der EEPROM-Adressen:
//uint16_t AT24Adresse;		//Zhlvariable fr Adressen des AT24C08 EEPROMs
//uint32_t LC1025Adresse = 0;	

//globale Varible fr zum Erkennen,ob sich am Sync-Status etwas gendert hat. Nur nach nderung soll ins EEPROM gespeichert werden.
uint8_t sync_status_alt = 0;	//knnte man evtl noch ins bereits vorhandene Struct mit einarbeiten

//############################################################################
//Overflow Interrupt wird ausgelst bei 59Sekunde oder fehlenden DCF77 Signal 
SIGNAL (SIG_OVERFLOW1)		//ist korrekt. 16-Bit-Timer1-berlauf. Dieser wurde zuvor konfiguriert. LED PD6 toggelt korrekt.
//############################################################################
{   
   struct  DCF77_Bits *rx_buffer;
   rx_buffer = (struct DCF77_Bits*)(char*)&dcf_rx_buffer;

	  PORTD ^= (1 << PD6);    // LED toggeln PD6, schaltet um bei voller Minute oder jede Sekunde bei fehlendem Signal

      
   //Zurcksetzen des Timers
   TCNT1 = 65535 - (SYSCLK / 1024);
   //wurden alle 59 Bits empfangen und sind die Paritys richtig?
   if (rx_bit_counter == 59 && 
      flags.parity_P1 == rx_buffer->P1 && 
      flags.parity_P2 == rx_buffer->P2 &&
      flags.parity_P3 == rx_buffer->P3)
      //Alle 59Bits empfangen stellen der Uhr nach DCF77 Buffer
      {
      //Berechnung der Minuten BCD to HEX
      mm = rx_buffer->Min-((rx_buffer->Min/16)*6);
        
        if (mm != 0){mm--;}else{mm = 59; h_hh = 1;};
      
        //Berechnung der Stunden BCD to HEX
      hh = rx_buffer->Hour-((rx_buffer->Hour/16)*6);

      if (h_hh) {hh--;h_hh = 0;};
	
		//Wochentag hinzugefgt chr
	  weekday = rx_buffer->Weekday;

      //Berechnung des Tages BCD to HEX
      day= rx_buffer->Day-((rx_buffer->Day/16)*6); 
      //Berechnung des Monats BCD to HEX
      mon= rx_buffer->Month-((rx_buffer->Month/16)*6);
      //Berechnung des Jahres BCD to HEX
      year= 2000 + rx_buffer->Year-((rx_buffer->Year/16)*6);
      //Sekunden werden auf 0 zurckgesetzt
	  ss = 59;
      flags.dcf_sync = 1;
//#ifdef sync_memory_enabled
//	  sync_memory (hh, mm, day, mon, year, flags.dcf_sync);		//hinzugefgt fr Datensatz ins EEPROM
//#endif
      }
   else
      //nicht alle 59Bits empfangen bzw kein DCF77 Signal Uhr luft 
      //manuell weiter
      {
//	  PORTD ^= (1 << PD6);    // LED toggeln PD6, schaltet um bei voller Minute!!! Blinkt Sekundentakt ohne Signal. nur zu Debug-Zwecken
      Add_one_Second();
      flags.dcf_sync = 0;
//#ifdef sync_memory_enabled
//	  sync_memory (hh, mm, day, mon, year, flags.dcf_sync);		//hinzugefgt fr Datensatz ins EEPROM
//#endif
      }
   //zurcksetzen des RX Bit Counters
   rx_bit_counter = 0;
#ifdef use_I2C_LCD  
//   I2Clcd_clear();			//auf dem I2C-LCD soll die Zeile mit den Spezialbits gelscht werden, da dort oft Fehler stehen.
								//dieser Aufruf fhrt zu Programmabstrzen, oft schon nach ein oder zwei Minuten.
#endif   
   //Lschen des Rx Buffers
   dcf_rx_buffer = 0;
};

//############################################################################
//DCF77 Modul empfngt Trger 
SIGNAL (DCF77_INT)		//	#define DCF77_INT Interrupt 	SIG_INTERRUPT0	-->> an dem das DCF77 Modul hngt hier INT0 = PD2 = Pin4
//############################################################################
//Falls "steigende Flanke" -->> auf "fallende Flanke umschalten"
{
   //Auswertung der Pulseweite 
//	if (INT0_CONTROL == INT0_RISING_EDGE)	//fr positive Pulse
	if (INT0_CONTROL == INT0_FALLING_EDGE)	//gendert fr negative Pulse

      {
      flags.dcf_rx ^= 1;
      //Secunden Hilfs Counter berechnen // SYSCLK defined in USART.H
      h_ss = h_ss + TCNT1 - (65535 - (SYSCLK / 1024));
      //Zurcksetzen des Timers
      TCNT1 = 65535 - (SYSCLK / 1024);								//wird bei steigender und fallender Flanke gesetzt
      //ist eine Secunde verstrichen // SYSCLK defined in USART.H
      if (h_ss > (SYSCLK / 1024 / 100 * 90)) //90% von 1Sekunde
         {
	 	  PORTD ^= (1 << PD7);    // LED toggeln PD7, schaltet um bei jeder Sekunde!!! nur zu Debug-Zwecken

         //Addiere +1 zu Sekunden
         Add_one_Second();
         //Zurcksetzen des Hilfs Counters
         h_ss = 0;
         };
      //Nchster Interrupt wird ausgelst bei abfallender Flanke
//	  INT0_CONTROL = INT0_FALLING_EDGE;	//fr positive Pulse
      INT0_CONTROL = INT0_RISING_EDGE;	//gendert fr negative Pulse
      }
   else		//sonst (wenn es also die fallende Flanke ist), auf "steigende Flanke umschalten" 
      {
      //Auslesen der Pulsweite von ansteigender Flanke zu abfallender Flanke
      unsigned int pulse_wide = TCNT1;	//Achtung! hier wird tatschlich bei jeder ELSE-Verzweigung das Timer-Register gelesen!!!
      //Zurcksetzen des Timers
      TCNT1 = 65535 - (SYSCLK / 1024);			//57722				//wird bei steigender und fallender Flanke gesetzt
      //Secunden Hilfs Counter berechnen
      h_ss = h_ss + pulse_wide - (65535 - (SYSCLK / 1024));
      //Parity speichern
      //beginn von Bereich P1/P2/P3
      if (rx_bit_counter ==  21 || rx_bit_counter ==  29 || rx_bit_counter ==  36) 
         {
         flags.parity_err = 0;	//Immer zu Beginn eines Parity-Bereichs die Variable lschen. Beginn mit gelschtem Fehler.
         };
      //Speichern von P1			//hier knnte man noch die Bits 15, 16, 17+18 und 19 auswerten, sowie aufs Terminal schreiben lassen.
									//if (rx_bit_counter ==  15) usart_write_char('1') ; else usart_write_char('0');	//Antenne
									//if (rx_bit_counter ==  16) usart_write_char('1') ; else usart_write_char('0');	//Zeitumstellung
									//if (rx_bit_counter ==  19) usart_write_char('1') ; else usart_write_char('0');	//Schaltsekunde
      if (rx_bit_counter ==  28) {flags.parity_P1 = flags.parity_err;};
      //Speichern von P2
      if (rx_bit_counter ==  35) {flags.parity_P2 = flags.parity_err;};	//spter das getoggelte Parity-Bit dem passenden Flag zuordnen.
      //Speichern von P3
      if (rx_bit_counter ==  58) {flags.parity_P3 = flags.parity_err;};
      //berprfen ob eine 0 oder eine 1 empfangen wurde
      //0 = 100ms
      //1 = 200ms
      //Abfrage grer als 150ms (15% von 1Sekund also 150ms)   	//HIER > 200 ms, das sind die Einsen.
      if (pulse_wide > (65535 - (SYSCLK / 1024)/100*85))			//if (pulse_wide > 58894)
         {
		 PORTD ^= (1 << PD5);    // LED toggeln PD5, blinkt Sekundentakt kurz VOR LED PD7 bei falscher Pulspolaritt. Toggelt bei langem Puls bei richtiger Polaritt.
         //Schreiben einer 1 im dcf_rx_buffer an der Bitstelle rx_bit_counter
         dcf_rx_buffer = dcf_rx_buffer | ((unsigned long long) 1 << rx_bit_counter);		//startet bei 0 
         //Toggel Hilfs Parity
         flags.parity_err = flags.parity_err ^ 1;	//Einmal toggeln bedeutet ungerade Anzahl, zweimal toggeln ergibt gerade Anzahl. Man braucht gar keinen Zhler,
         }//der die Einsen zhlt. Im Prinzip ist das hier der Zhler, der aber nur ein einziges Bit verwendet.
      //Nchster Interrupt wird ausgelst bei ansteigender Flanke
//		INT0_CONTROL = INT0_RISING_EDGE;		//fr positive Pulse
		INT0_CONTROL = INT0_FALLING_EDGE;		//gendert fr negative Pulse
      //RX Bit Counter wird um 1 incrementiert
      rx_bit_counter++;
      }
};

//############################################################################
//Addiert 1 Sekunde
void Add_one_Second (void)
//############################################################################
{
   ss++;//Addiere +1 zu Sekunden
   if (ss == 60)
   {
      ss = 0;
      mm++;//Addiere +1 zu Minuten
      if (mm == 60)
      {
         mm = 0;
         hh++;//Addiere +1 zu Stunden
         if (hh == 24)
         {
            hh = 0;
         }
      }
   }
};

//############################################################################
//Diese Routine startet und initialisiert den 16-Bit-Timer1 fr DCF77 Dekodierung
void Start_Clock (void)
//############################################################################
{
   //Interrupt DCF77 einschalten auf ansteigende Flanke
	DCF77_INT_ENABLE();						//#define DCF77_INT_ENABLE()	EIMSK |= (1<<INT0);
//	INT0_CONTROL = INT0_RISING_EDGE;			//#define INT0_CONTROL		EICRA		//fr positive Pulse
	INT0_CONTROL = INT0_FALLING_EDGE; 		// fr negative Pulse
	DDRD = (1<<PD5)|(1<<PD6)|(1<<PD7);	// PD5, PD6, PD7 sollen Ausgnge sein fr LEDs, nur zu Debug-Zwecken
     
   //Interrupt Overflow enable
	TIMSK1 |= (1 << TOIE1);
	//Setzen des Prescaler auf 1024 	--->>> nderung Christian fr Mega48: 		1 0 1 clkI/O/1024 (from prescaler)
	TCCR1B |= (1<<CS10 | 1<<CS12);	//--->>> nderung Christian fr Mega48: 		1 0 1 clkI/O/1024 (from prescaler)
    //SYSCLK defined in USART.H
	TCNT1 = 65535 - (SYSCLK / 1024);	//57722,5	-->> eine Sekunde ist vergangen nach genau 7812,5 Takten. Dann erfolgt berlauf.
	return;
};

//############################################################################
//Diese Routine startet und initialisiert den Timer0 fr RC5-Empfang
void Start_RC5 (void)
//############################################################################
{
//	TCCR0B = (1<<CS01) | (1<<CS00);			//divide by 64; korrekt fr 2MHz
	TCCR0B = 1<<CS02;			//divide by 256; korrekt fr 8MHz
	TIMSK0 |= 1<<TOIE0;			//enable timer interrupt
	return;
};



//neue Schleife, um die 64-Bit-Variable endlich richtig anzeigen. verwendet if (k & ((unsigned long long) 1 << j))
//Schleife soll von 64 bis 1 (j=64; j>0; j--) oder 63 bis 0 gehen.
//Bit 0...58 sind definiert, Bit 59 entfllt wegen Minuten-Erkennung, 60 = 0.
void Alle_bits_anzeigen1 (unsigned long long k)	//zeigt Bit - Nr 0..59 also 60 Bits an
	{
//	uint8_t j;	//gehrt zu falsch anzeogendern Version for (j=64; j>0; j--)
	int16_t  j;
//	unsigned long long Filter = 0x1000000000000000;	//wichtig!!! mu als Hex-Zahl angegeben sein, die 1 startet links
	
	
//	if (k & ((unsigned long long) 1 << j)) usart_write_char('1'); else usart_write_char('0');	//gelscht in Version clock5b.
	
//	for (j=64; j>0; j--)		//schreibt rechts die niederwertigsten Bits der Variablen (j=59; j>0; j--) bringt rechts eine Stelle zu wenig und links eine zu viel
	for (j=63; j>= 0; j--)	//gleicher Fehler: bringt links immer noch eine Stelle zu wenig
		{
		if (k & ((unsigned long long) 1 << j)) usart_write_char('1'); else usart_write_char('0');
		//wenn BitX high ist, soll eine 1 geschrieben werden, sonst 0
		if ((j == 15)|(j == 20 )|(j == 21 )|(j == 28)|(j == 29 )|(j == 35 )|(j == 36)|(j == 42)|(j == 45)|(j == 50 )|(j == 58 )|(j == 59)) usart_write_char('-') ;
		}
		
	}
//Enthlt noch einen Fehler!!!!!!!!!!!!!!!!
//ganz links erscheint unerwnscht das niederwertigste Bit. Dieses sollte aber ganz rechts erscheinen!!!!
//ganz links erscheint die 65. Stelle, die unerwnscht ist.
//mte man gezielt untersuchen, warum. (k & ((unsigned long long) 1 << j)) mal mit k aus lauter Einsen verunden und schauen, was raus kommt.


void Wochentag_anzeigen (void)	//hinzugefgt chr; funktioniert, dahinter evtl noch ein Leerzeichen bringen in "main.c"
	{
	switch (weekday)
		{
		case 1:			usart_write("Mo"); break;
		case 2:			usart_write("Di"); break;
		case 3:			usart_write("Mi"); break;
		case 4:			usart_write("Do"); break;
		case 5:			usart_write("Fr"); break;
		case 6:			usart_write("Sa"); break;
		case 7:			usart_write("So"); break;
		}
	}


//Ausgabe nur aufs Terminal ber RS232
void Spezial_bits_anzeigen (void)	//void hinzugefgt in Version clock5b.c
	{
	struct  DCF77_Bits *rx_buffer;								//Deklaration mu hier wiederholt werden
	rx_buffer = (struct DCF77_Bits*)(char*)&dcf_rx_buffer;		//Deklaration mu hier wiederholt werden
//	if (rx_buffer->R) 	usart_write("Reserveantenne ");			//0=Normalantenne, 1=Reserveantenne
	if (rx_buffer->R) 	usart_write("Ruf ");	
	if (rx_buffer->A1)	usart_write("Zeitumstellung ");			// 1=Am Ende dieser Stunde wird MEZ/MESZ umgestellt
	if (rx_buffer->Z1)	usart_write("MESZ ");					//1=MESZ, 0=MEZ
	if (rx_buffer->Z2)	usart_write("MEZ ");					//1=MEZ, 0=MESZ
	if (rx_buffer->A2)	usart_write("Schaltsekunde ");			//1=Am Ende dieser Stunde wird eine Schaltsekunde eingefgt
}
	
//Ausgabe nur aufs I2C-LCD ber PCF8574
void Spezial_bits_anzeigen_I2C_4x40 (void)	//knnte man auch kombinieren im bisherigen Unterprogramm "Spezial_bits_anzeigen"
	{
	struct  DCF77_Bits *rx_buffer;							//Deklaration mu hier wiederholt werden
	rx_buffer = (struct DCF77_Bits*)(char*)&dcf_rx_buffer;	//Deklaration mu hier wiederholt werden
	I2Clcd_setcursor( 0, 1 );			//Spalte 0, Zeile1
//	if (rx_buffer->R) 	I2Clcd_string("Reserveantenne ");	//0=Normalantenne, 1=Reserveantenne
	if (rx_buffer->R) 	I2Clcd_string("Ruf ");	
	if (rx_buffer->A1)	I2Clcd_string("Zeitumstellung ");	// 1=Am Ende dieser Stunde wird MEZ/MESZ umgestellt
	if (rx_buffer->Z1)	I2Clcd_string("MESZ ");				//1=MESZ, 0=MEZ
	if (rx_buffer->Z2)	I2Clcd_string("MEZ ");				//1=MEZ, 0=MESZ
	if (rx_buffer->A2)	I2Clcd_string("Schaltsekunde ");	//1=Am Ende dieser Stunde wird eine Schaltsekunde eingefgt
	}

void I2C_Wochentag_anzeigen (void)	//hinzugefgt chr; funktioniert, dahinter evtl noch ein Leerzeichen bringen in "main.c"
	{
	switch (weekday)
		{
		case 1:			I2Clcd_string("Mo"); break;
		case 2:			I2Clcd_string("Di"); break;
		case 3:			I2Clcd_string("Mi"); break;
		case 4:			I2Clcd_string("Do"); break;
		case 5:			I2Clcd_string("Fr"); break;
		case 6:			I2Clcd_string("Sa"); break;
		case 7:			I2Clcd_string("So"); break;
		}
	}

void Uhrzeit_auf_I2C_LCD_ausgeben (void)
	{
	I2Clcd_setcursor( 0, 2 );			//Spalte 0, Zeile2
	I2C_Wochentag_anzeigen();			//ganz links mit dem Wochentag beginnen

//am besten den wiederkehrenden Ablauf mittels Zeiger auf die verschiedenen Variablen realisieren.
	I2Clcd_data(' ');

	itoa( day, Buffer, 10);		//
	I2Clcd_string( Buffer ); 

	I2Clcd_data(' ');
	
	itoa( mon, Buffer, 10);		//
	I2Clcd_string( Buffer ); 
	
	I2Clcd_data(' ');
	
	itoa( year, Buffer, 10);		//
	I2Clcd_string( Buffer ); 	
	
	I2Clcd_data(' ');
	
	itoa( hh, Buffer, 10);		//
	I2Clcd_string( Buffer ); 
	
	I2Clcd_data(' ');
	
	itoa( mm, Buffer, 10);		//
	I2Clcd_string( Buffer ); 
	
	I2Clcd_data(' ');
	
	itoa( ss, Buffer, 10);		//
	I2Clcd_string( Buffer ); 
	
	}
	

//Ausgabe nur aufs I2C-LCD ber PCF8574
void Spezial_bits_15_19_anzeigen_I2C_4x40 (void)	//knnte man auch kombinieren im bisherigen Unterprogramm "Spezial_bits_anzeigen"
	{
	struct  DCF77_Bits *rx_buffer;							//Deklaration mu hier wiederholt werden
	rx_buffer = (struct DCF77_Bits*)(char*)&dcf_rx_buffer;	//Deklaration mu hier wiederholt werden
	I2Clcd_setcursor( 0, 4 );			//Spalte 0, Zeile4
	I2Clcd_string("Bits 15..19 ");
	
	if (rx_buffer->R) 	I2Clcd_data('1'); else 	I2Clcd_data('0');	//0=Normalantenne, 1=Reserveantenne
	if (rx_buffer->A1)	I2Clcd_data('1'); else 	I2Clcd_data('0');	//1=Am Ende dieser Stunde wird MEZ/MESZ umgestellt
	if (rx_buffer->Z1)	I2Clcd_data('1'); else 	I2Clcd_data('0');	//1=MESZ, 0=MEZ
	if (rx_buffer->Z2)	I2Clcd_data('1'); else 	I2Clcd_data('0');	//1=MEZ, 0=MESZ
	if (rx_buffer->A2)	I2Clcd_data('1'); else 	I2Clcd_data('0');	//1=Am Ende dieser Stunde wird eine Schaltsekunde eingefgt

	//falls alle Bits 15..19 gelscht sind, das Display lschen
	//if ((rx_buffer->R) & (rx_buffer->A1) & (rx_buffer->Z1) & (rx_buffer->Z2) & (rx_buffer->A2) = 0) I2Clcd_clear();
	}

/*
void Spezial_bits_15_19_anzeigen_I2C_4x40 (unsigned long long k)	//funktioniert nicht!
	{
	int16_t  j;
	usart_write("\n\r");
	for (j=20; j>= 14; j--)	//
		{
		if (k & ((unsigned long long) 1 << j)) usart_write_char('1'); else usart_write_char('0');
		//wenn BitX high ist, soll eine 1 geschrieben werden, sonst 0
		//if ((j == 15)|(j == 20 )|(j == 21 )|(j == 28)|(j == 29 )|(j == 35 )|(j == 36)|(j == 42)|(j == 45)|(j == 50 )|(j == 58 )|(j == 59)) usart_write_char('-') ;
		usart_write("\n\r");
		
		I2Clcd_setcursor( 0, 4 );			//Spalte 0, Zeile4
		if (k & ((unsigned long long) 1 << j)) I2Clcd_data('1'); else I2Clcd_data('1');
		}
	}
*/