/*#######################################################################################
AVR DCF77 Clock 

Copyright (C) 2005 Ulrich Radig

http://www.ulrichradig.de/home/index.php/avr/dcf77_uhr
http://www.ulrichradig.de/home/uploads/File/AVR_DCF77/SourceCode.zip

passt fr IRMP-Schaltung

Der Anschlu des DCF77 Empfnger erfolgt an Interrupt0 
mit einen 10KOhm Widerstand nach VCC (+5V).


main3.c ist im neuen Verzeichnis "DCF77Radig_I2C" neu. es soll eine Ausgabe ber das per I2C angeschlossene LCD hinzu kommen
fr das 2x40 LCD oder das 4x40 LCD mit Beleuchtung. 
Hierfr neu hinzu:
pcf8574.c
pcf8574.h
LCD-RoutinesI2C-4x40.h
lcd-routines_i2c-4x40.c
oder
LCD-RoutinesI2C.h
lcd-routines_i2c.c

anstelle usart.c usart_i2c.c verwenden zur Ausgabe aufs Display	-->> funktioniert grundstzlich wie erwartet, 
bringt aber noch Fehler bzw die Ausgabe darf nicht lnger als eine Displayzeile sein.

#######################################################################################*/

#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "clock.h"
#include "usart.h"
#include <util/delay.h>			//fr delay hinzu gefgt

//#include "LCD-Routines.h"			//fr neue Schaltung normales LCD
#include "LCD-RoutinesI2C-4x40.h"	//fr neue Schaltung 4x40 LCD mit Licht
#include "LCD-RoutinesI2C.h"		//fr neue Schaltung 2x40 LCD ohne Licht

//#define Mega8	= 1		//fr AVR Mega8
#define Mega168 = 1	//fr AVR Mega168, Mega88, Mega48 falls das Programm grer als 8 kBytes wird.
//#define use_DS18S20
//#define use_UART

//uint16_t j;			//in main, Zhlvariable fr AT24C08 EEPROM-Schreiben und Lesen
					//mu (!) eine 16-Bit Variable sein, da die AT24C08-Unterprogramme ebenfalls 16-Bit-Variablen enthalten.
					
//uint32_t k;			//in main, Zhlvariable fr 24LC1025 EEPROM-Schreiben und Lesen
					//mu (!) eine 32-Bit Variable sein, da die AT24C1025-Unterprogramme ebenfalls 32-Bit-Variablen enthalten.
//uint_32t untereadresse;	//fr AT24LC1025_Inhalt_anzeigen(); Parameter Startadresse

uint8_t	zaehlvariable;

char Buffer[10];	//fr itoa, fr EEPROM-Schreiben und Lesen


//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	//Inizialisierung der Seriellen Schnittstelle
	usart_init(9600);


#ifdef use_I2C_LCD
//I2C-LCD initialisieren************************************
	pcf8574_init();		//I2C  initialisieren
// LCD, das am PCF8574 angeschlossen ist,  initialisieren
#endif

	Start_RC5();		//RC5-Empfang initialisieren

#ifdef use_I2C_LCD
	I2Clcd_init();
	I2Clcd_string("DCF77 Uhr Ulrich Radig mit 4x40 LCD");	//landet in dritter Zeile 
#endif
// Ende I2C-LCD********************************************

	//Globale Interrupts einschalten
	sei();

	//Starten der DCF77 Uhr
	Start_Clock();
	//LCD_Clear();
	usart_write ("\nDCF 77 Clock by Ulrich Radig\n\n");
    
	
	//Ausgabe der Zeit auf der Seriellen Schnittstelle in einer Endlosschleife
	while (1)
	{
/*
#ifdef use_I2C_LCD
	zaehlvariable++;
	I2Clcd_setcursor( 1, 4 );			//Spalte 1, Zeile4
	itoa( zaehlvariable, Buffer, 10);		//
//	itoa( tick, s, 10);		//
	I2Clcd_string( Buffer ); 
	
//	I2Clcd_setcursor( 10, 1 );			//Spalte 10, Zeile1
//	I2Clcd_string( Buffer );	
#endif
*/
	
/*	
		Alle_bits_anzeigen1 (dcf_rx_buffer);	//Ausgabe aller 60 Bits aufs UART
		usart_write("  ");
		Spezial_bits_anzeigen();
		Wochentag_anzeigen();
*/

		Wochentag_anzeigen();	//<<--<<-- wieder hinzu nehmen

//frs LCD darf die Ausgabe nicht mehr Zeichen haben als das Display in einer Zeile darstellen kann. Besser diese Konstruktion fr jede Zeile neu verwenden.
//		usart_write("%i-%i-%i Time: %i:%i:%i Sync: %i \r",			// %i fr ganze Integer-Zahlen zur Basis 10, \r = Wagenrcklauf
//				day,mon,year,hh,mm,ss,flags.dcf_sync);

//		usart_write("%i-%i-%i Time: %i:%i:%i Sync: %i  Rx: %i       \r",			// %i fr ganze Integer-Zahlen zur Basis 10, \r = Wagenrcklauf
//				day,mon,year,hh,mm,ss,flags.dcf_sync,flags.dcf_rx);

		
		usart_write("%i-%i-%i Time: %i:%i:%i Sync: %i  Rx: %i  Bitcounter: %i \n",
				day,mon,year,hh,mm,ss,flags.dcf_sync,flags.dcf_rx,rx_bit_counter);	//bitcounter 0..59 soll zustzlich ausgegeben werden. \n = neue Zeile



		usart_write("\n\r");	
		usart_write("\n");	
		Alle_bits_anzeigen1 (dcf_rx_buffer);	//Ausgabe aller 60 Bits aufs UART	<<--<<-- wieder hinzu nehmen
		usart_write("\n\r");
//		Spezial_bits_anzeigen ();//Ausgabe des Antennen-Bits Nr15, des Warnungs-Bits fr die Zeitumstellung bit 16, Schaltsekunde Bit19 Vorwarnungs-Bit,
//		usart_write("  ");
		
		Spezial_bits_anzeigen();	//<<--<<-- wieder hinzu nehmen


		Spezial_bits_anzeigen_I2C_4x40();	//OK, geht, zeigt in erster Zeile auf dem 4x40 Display an<<--<<-- wieder hinzu nehmen
		Uhrzeit_auf_I2C_LCD_ausgeben();		//OK, geht, zeigt in zweiter Zeile an<<--<<-- wieder hinzu nehmen
						
		RC5_Empfang();				//Ausgabe erscheint hinter dem DCF77-Empfang, bringt "neue Zeile"


		Spezial_bits_15_19_anzeigen_I2C_4x40();
		
		usart_write("\r");			//nur Wagenrcklauf, keine neue Zeile

		//Wait a schort time
//		for (long i=0;i<90000000;i++){};
		for (long i=0;i<10000000;i++){};
	}
return (1);
}

