/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/
#include "RC5.h"
//#include <util/delay.h>
//#include <io.h>
//#include <interrupt.h>
//#include <signal.h>
//#include <stdlib.h>

#define RC5TIME 	1.778e-3		// 1.778msec
#define PULSE_MIN	(uchar)(XTAL / 512 * RC5TIME * 0.4 + 0.5)
#define PULSE_1_2	(uchar)(XTAL / 512 * RC5TIME * 0.8 + 0.5)
#define PULSE_MAX	(uchar)(XTAL / 512 * RC5TIME * 1.2 + 0.5)


uchar	rc5_bit;				// bit value
uchar	rc5_time;				// count bit time
uint	rc5_tmp;				// shift bits in
volatile uint	rc5_data;				// store result
unsigned int i;					//war zuvor in clock5.c		fr "void RC5_Empfang ()"


ISR (TIMER0_OVF_vect)	//Timer/Counter0 Overflow auf neue Version umgeschrieben!!!!!!!!!!!
{
  uint tmp = rc5_tmp;				// for faster access

  TCNT0 = -2;					// 2 * 256 = 512 cycle
  
//  		PORTB ^= (1 << PB1);    // LED toggeln PB1
//				 _delay_ms( 25 );

  if( ++rc5_time > PULSE_MAX ){			// count pulse time
    if( !(tmp & 0x4000) && tmp & 0x2000 )	// only if 14 bits received
      rc5_data = tmp;
    tmp = 0;
  }

  if( (rc5_bit ^ xRC5_IN) & 1<<xRC5 ){		// change detect
    rc5_bit = ~rc5_bit;				// 0x00 -> 0xFF -> 0x00

    if( rc5_time < PULSE_MIN )			// to short
      tmp = 0;

    if( !tmp || rc5_time > PULSE_1_2 ){		// start or long pulse time
      if( !(tmp & 0x4000) )			// not to many bits
        tmp <<= 1;				// shift
      if( !(rc5_bit & 1<<xRC5) )		// inverted bit
        tmp |= 1;				// insert new bit
      rc5_time = 0;				// count next pulse time
    }
  }

  rc5_tmp = tmp;
}


void RC5_Empfang ()
	{
	 struct  DCF77_Bits *rx_buffer;
	 rx_buffer = (struct DCF77_Bits*)(char*)&dcf_rx_buffer;
	
	cli();
    i = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();
	
    if( i ){
//			lcd_setcursor( 22, 2 );		//Spalte 22, Zeile2  durch Ausprobieren eine sinnnvolle Stelle auf dem Display finden
//			lcd_data( ( i >> 11 & 1) + '0' );
			usart_write_char(( i >> 11 & 1) + '0');	// Toggle Bit
			
//			lcd_data( ' ');
			usart_write_char(' ');
			
			itoa( i >> 6 & 0x1F, Buffer, 10);	// Device address
//			lcd_string( Buffer );
			usart_write_str( Buffer );
			
//			lcd_data( ' ');
			usart_write_char(' ');
			
	  		//itoa((i & 0x3F) | (~i >> 7 & 0x40), Buffer, 10);	// Key Code   s ist ein character-array mit 30 Zeichen
			itoa((i & 0x3F) | (~i >> 6 & 0x40), Buffer, 10);	//Achtung!!! hier die Korrktur anbringen 6 anstatt 7 schreiben
			
//			lcd_string( Buffer );
			usart_write_str( Buffer );
			usart_write_str ("\n\r");
//			_delay_ms( 300); //Anzeige soll nicht gleich verlschen

	//******************Bedienung von Funktonen ber RC5-Fernbedienung:***************

	if( ((i & 0x3F) | (~i >> 6 & 0x40)) == 53 ) 	 I2Clcd_clear();


	//******************Ende Bedienung	**********************************************
	
	}	//Ende if(i)
	}	//Ende RC5-Empfang
